package adsjava;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.sql.*;
import java.util.*;
import com.borland.dx.sql.dataset.Database;
import com.borland.dx.sql.dataset.ConnectionDescriptor;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class MainFrame extends JFrame {
  Connection conn;
  Statement stmt;
  PreparedStatement prepStmt;
  JPanel contentPane;
  JLabel jLabel1 = new JLabel();
  JTextField selectText = new JTextField();
  JButton executeSelect = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  JLabel jLabel2 = new JLabel();
  JTextField paramText = new JTextField();
  JButton showInvoiceBtn = new JButton();
  JLabel jLabel3 = new JLabel();
  JTextField custNoText = new JTextField();
  JButton getAddressBtn = new JButton();
  JButton setAddressBtn = new JButton();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JTextField oldAddressText = new JTextField();
  JTextField newAddressText = new JTextField();
  JTable jTable1 = new JTable();
  JButton createTableBtn = new JButton();
  JLabel jLabel6 = new JLabel();
  JTextField tableNameText = new JTextField();
  JButton changePasswordBtn = new JButton();
  JButton callStoredProcBtn = new JButton();
  JButton listProductsBtn = new JButton();
  JButton clearListBtn = new JButton();
  JScrollPane jScrollPane2 = new JScrollPane();
  JList productList = new JList();
  GridBagLayout gridBagLayout1 = new GridBagLayout();

  //Construct the frame
  public MainFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
       databaseInit();
       jbInit();

    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    contentPane = (JPanel)this.getContentPane();
    jLabel1.setText("SELECT Statement");
    contentPane.setLayout(gridBagLayout1);
    this.setSize(new Dimension(686, 475));
    this.setTitle("ADS and Java");
    contentPane.setMinimumSize(new Dimension(135, 30));
    contentPane.setPreferredSize(new Dimension(135, 35));
    executeSelect.setText("Execute SELECT");
    executeSelect.addActionListener(new MainFrame_executeSelect_actionAdapter(this));
    executeSelect.addActionListener(new MainFrame_executeSelect_actionAdapter(this));
    executeSelect.addActionListener(new MainFrame_executeSelect_actionAdapter(this));
    jLabel2.setText("Show invoices for Customer Number");
    paramText.setText("");
    paramText.setColumns(12);
    showInvoiceBtn.setText("Show Invoices");
    showInvoiceBtn.addActionListener(new MainFrame_showInvoiceBtn_actionAdapter(this));
    showInvoiceBtn.addActionListener(new MainFrame_showInvoiceBtn_actionAdapter(this));
    jLabel3.setText("Customer Number");
    custNoText.setText("");
    custNoText.setColumns(12);
    getAddressBtn.setText("Get Address");
    getAddressBtn.addActionListener(new MainFrame_getAddressBtn_actionAdapter(this));
    setAddressBtn.setText("Set New Address");
    setAddressBtn.addActionListener(new MainFrame_setAddressBtn_actionAdapter(this));
    jLabel4.setText("Old Address");
    jLabel5.setText("New Address");
    oldAddressText.setText("");
    oldAddressText.setColumns(30);
    newAddressText.setText("");
    createTableBtn.setText("Create Table and Grant Rights");
    createTableBtn.addActionListener(new MainFrame_createTableBtn_actionAdapter(this));
    jLabel6.setText("Table to add (ex: DEMO7)");
    tableNameText.setText("");
    changePasswordBtn.setText("Change Password");
    changePasswordBtn.addActionListener(new MainFrame_changePasswordBtn_actionAdapter(this));
    callStoredProcBtn.setText("Show 10% of Invoices");
    callStoredProcBtn.addActionListener(new MainFrame_callStoredProcBtn_actionAdapter(this));
    listProductsBtn.setText("List Products");
    listProductsBtn.addActionListener(new MainFrame_listProductsBtn_actionAdapter(this));
    clearListBtn.setText("Clear List");
    clearListBtn.addActionListener(new MainFrame_clearListBtn_actionAdapter(this));
    contentPane.add(jLabel1,          new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 20, 0));
    contentPane.add(listProductsBtn,           new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 60, 0));
    contentPane.add(jLabel3,    new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(14, 0, 0, 0), 0, 0));
    contentPane.add(getAddressBtn,    new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 40, 0));
    contentPane.add(jScrollPane2,    new GridBagConstraints(1, 1, 2, 2, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(6, 0, 0, 15), -116, -60));
    contentPane.add(clearListBtn,     new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 22, 0));
    contentPane.add(custNoText,  new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(13, 0, 0, 48), 0, 0));
    contentPane.add(setAddressBtn,      new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 60, 0));
    contentPane.add(callStoredProcBtn,             new GridBagConstraints(4, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 44, 2));
    contentPane.add(selectText,  new GridBagConstraints(1, 0, 3, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(6, 0, 0, 0), 257, 0));
    contentPane.add(tableNameText,  new GridBagConstraints(0, 6, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(11, 1, 0, 0), 118, 1));
    contentPane.add(changePasswordBtn,              new GridBagConstraints(0, 7, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 54, 0));
    contentPane.add(jLabel4,  new GridBagConstraints(2, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(20, 10, 0, 6), 0, 0));
    contentPane.add(jLabel5,  new GridBagConstraints(2, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(14, 9, 0, 0), 0, 0));
    contentPane.add(jLabel6,     new GridBagConstraints(0, 5, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0));
    contentPane.add(createTableBtn,    new GridBagConstraints(1, 6, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(11, 0, 0, 0), 36, 3));
    contentPane.add(newAddressText,  new GridBagConstraints(3, 4, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(11, 0, 0, 0), 167, 0));
    contentPane.add(jLabel2,     new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 60, 0));
    contentPane.add(paramText,        new GridBagConstraints(3, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(10, 0, 0, 0), 50, 0));
    contentPane.add(oldAddressText,  new GridBagConstraints(3, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(11, 0, 0, 0), -67, 0));
    contentPane.add(showInvoiceBtn,       new GridBagConstraints(4, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 44, 2));
    contentPane.add(executeSelect,  new GridBagConstraints(4, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(6, 10, 0, 27), 0, 0));
    contentPane.add(jScrollPane1,      new GridBagConstraints(0, 8, 5, 1, 1.0, 1.0
            ,GridBagConstraints.NORTH, GridBagConstraints.BOTH, new Insets(3, 1, 3, 1), 230, 100));
    jScrollPane1.getViewport().add(jTable1, null);
    jScrollPane2.getViewport().add(productList, null);
  }

  private void databaseInit() throws Exception{
    Class.forName("com.extendedsystems.jdbc.advantage.ADSDriver");
    conn = DriverManager.getConnection("jdbc:extendedsystems:" +
      "advantage://server:6262/share/adsbook/" +
      "demodictionary.add;user=adsuser;password=password");
    stmt = conn.createStatement();
    prepStmt = conn.prepareStatement( "SELECT * FROM INVOICE "+
      "WHERE [customer id] = ?" );
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  public static boolean isRSEmpty(ResultSet rs) {
    try {
      return ! rs.first();
    }
    catch (Exception e1) {
      System.err.println( e1.getMessage());
      return false;
    }
  }

  void executeSelect_actionPerformed(ActionEvent e) {
    try {
      ResultSet rs = stmt.executeQuery(selectText.getText());

      if (isRSEmpty(rs)) {
        JOptionPane.showMessageDialog(this,
         "No records in result set");
        return;
      }
      jTable1.setModel(new ResultTableModel(rs));
    }
    catch (Exception e1) {
      System.err.println( e1.getMessage());
    }
  }

  void showInvoiceBtn_actionPerformed(ActionEvent e) {
    try{
      prepStmt.setInt( 1, Integer.parseInt(paramText.getText()));
      ResultSet rs = prepStmt.executeQuery();
      if (isRSEmpty(rs)) {
        JOptionPane.showMessageDialog(this,
         "No records in result set");
        return;
      }
      jTable1.setModel(new ResultTableModel(rs));
    }
    catch (Exception e1) {
      System.err.println( e1.getMessage());
    }
  }

  void getAddressBtn_actionPerformed(ActionEvent e) {
    PreparedStatement getCustStmt;
    if (custNoText.getText() == "") {
      System.out.println("Enter a customer ID");
      return;
    }
    try {
      getCustStmt = conn.prepareStatement(
        "SELECT * FROM CUSTOMER WHERE [customer id] = ?" );
      getCustStmt.setInt( 1,
        Integer.parseInt(custNoText.getText()));

      ResultSet rs = getCustStmt.executeQuery();
      if (isRSEmpty(rs)) {
        JOptionPane.showMessageDialog(this,
         "No records in result set");
        jTable1.setModel(new ResultTableModel(null));
        return;
      }
      oldAddressText.setText(rs.getString("Address"));
      jTable1.setModel(new ResultTableModel(rs));
    }
    catch (Exception e1) {
      System.err.println( e1.getMessage());
    }
  }

  void setAddressBtn_actionPerformed(ActionEvent e) {
    PreparedStatement getCustStmt;

    if (custNoText.getText() == "") {
      System.out.println("Enter a customer ID");
      return;
    }
    try {
      getCustStmt = conn.prepareStatement(
        "SELECT * FROM CUSTOMER WHERE [customer id] = ?" );
      getCustStmt.setInt( 1,
        Integer.parseInt(custNoText.getText()));

      ResultSet rs = getCustStmt.executeQuery();
      if (isRSEmpty(rs)) {
        JOptionPane.showMessageDialog(this,
         "No records in result set");
        return;
      }
      rs.updateString("Address", newAddressText.getText());
      rs.updateRow();
    }
    catch (Exception e1) {
      System.err.println( e1.getMessage());
    }
  }

  void createTableBtn_actionPerformed(ActionEvent e) {
    boolean found = false;
    Connection adminconn;
    Statement adminstmt;
    Statement grantstmt;
    ResultSet rs;
    String tn = tableNameText.getText();

    //Check for semicolon hack
    if (! (tn.indexOf(";") == -1)) {
      JOptionPane.showMessageDialog(this,
        "Table name may not contain a semicolon");
      return;
    }

    if (tableNameText.getText().equals("")) {
       JOptionPane.showMessageDialog(this,
         "Please enter a table name");
      return;
    }

    try {
      adminconn = DriverManager.getConnection(
        "jdbc:extendedsystems:advantage://server:6262/share" +
        "/adsbook/demodictionary.add;" +
        "user=adssys;" +
        //Add the password if ADSSYS uses a password
        //"password=password"
        );
      adminstmt = adminconn.createStatement();
      rs =
        adminstmt.executeQuery("SELECT NAME FROM "+
          "\"system\".\"tables\"");

      String tabName;
      if (! isRSEmpty(rs)) {
        rs.first();
        do {
          tabName = rs.getString("Name");
          if (tabName.equalsIgnoreCase(tn)) {
           found = true;
           break;
          }
        } while (rs.next());
      }

      if (found) {
        JOptionPane.showMessageDialog(this,
          "Table already exists. Cannot create");
        return;
      }

      adminstmt.execute("CREATE TABLE " +
        tableNameText.getText() +
        "([Full Name] CHAR(30)," +
        "[Date of Birth] DATE," +
        "[Credit Limit] MONEY, " +
        "Active LOGICAL)");

      rs = adminstmt.executeQuery("SELECT * FROM "+
        "\"system\".\"usergroups\"");

      if (isRSEmpty(rs)) {
        JOptionPane.showMessageDialog(this,
          "No groups to grant rights to");
        return;
      }

      grantstmt = adminconn.createStatement();

      rs.first();
      do {
        grantstmt.execute("GRANT ALL ON [" + tn + "]" +
          " TO [" +  rs.getString("Name") + "]");
      } while (rs.next());

    } catch (Exception e1) {
      System.out.println(e1.getMessage());
    }

  }

  void changePasswordBtn_actionPerformed(ActionEvent e) {
    String userName;
    String oldPass;
    String newPass1;
    String newPass2;

    try {
      ResultSet rs = stmt.executeQuery("SELECT USER() as Name " +
                                       "FROM \"system\".\"iota\"");
      rs.first();
      userName = rs.getString("Name");

      oldPass = JOptionPane.showInputDialog(this,
        "Enter your current password");

      if (oldPass.equals("")) {
        return;
      }

      try {
        Connection tempcon =
            DriverManager.getConnection(
            "jdbc:extendedsystems:advantage://server:6262/share" +
            "/adsbook/demodictionary.add;user=" + userName +
            ";password=" + oldPass);

      }
      catch (Exception e1) {
        JOptionPane.showMessageDialog(this,
            "Invalid password. Cannot change password");
        return;
      }
      //Check for semicolon hack
      newPass1 = JOptionPane.showInputDialog(this,
        "Enter your new password");
      if (! (newPass1.indexOf(";") == -1)) {
        JOptionPane.showMessageDialog(this,
          "Password may not contain a semicolon");
        return;
      }

      newPass2 = JOptionPane.showInputDialog(this,
        "Confirm your new password");

      if (!newPass1.equals(newPass2)) {
        JOptionPane.showMessageDialog(this,
            "Passwords did not match. Cannot change password");
        return;
      }

      //Create a new connection on the existing password to confirm its validity

      stmt.execute("EXECUTE PROCEDURE sp_ModifyUserProperty('" +
        userName + "', 'USER_PASSWORD', '" + newPass1 + "')");

      JOptionPane.showMessageDialog(this,
        "Password successfully changed. " +
          "New password will be valid next time you connect");
    } catch (Exception e1) {
      System.out.println(e1.getMessage());
    }
  }

  void callStoredProcBtn_actionPerformed(ActionEvent e) {
    PreparedStatement getCustStmt;
    if (custNoText.getText() == "") {
      System.out.println("Enter a customer ID");
      return;
    }
    try {
      getCustStmt = conn.prepareStatement(
        "EXECUTE PROCEDURE SQLGet10Percent( ? )" );
      getCustStmt.setInt( 1,
        Integer.parseInt(paramText.getText()));

      ResultSet rs = getCustStmt.executeQuery();
      if (isRSEmpty(rs)) {
        jTable1.setModel(new ResultTableModel(null));
        JOptionPane.showMessageDialog(this,
         "No records in result set");
        return;
      }
      jTable1.setModel(new ResultTableModel(rs));
    }
    catch (Exception e1) {
      JOptionPane.showMessageDialog(this,
        e1.getMessage());
    }
  }

  void listProductsBtn_actionPerformed(ActionEvent e) {
    DefaultListModel listModel = new javax.swing.DefaultListModel();
    try {
      ResultSet rs = stmt.executeQuery("SELECT * FROM PRODUCTS");
      rs.first();
      do {
        listModel.addElement(rs.getString(1) + "     " +
          rs.getString(2));
      } while (rs.next());

      productList.setModel(listModel);
    }
    catch (Exception e1) {
      System.err.println( e1.getMessage());
    }
  }

  void clearListBtn_actionPerformed(ActionEvent e) {
    DefaultListModel listModel = new javax.swing.DefaultListModel();
    productList.setModel(listModel);
  }

} //MainFrame

class ResultTableModel
  extends javax.swing.table.AbstractTableModel {
  Object obj [] [];
  int rows, columns;
  ResultSetMetaData rsMeta;

  public ResultTableModel (ResultSet rs) {
    try {
      if (rs == null) {
        rows = 0;
        columns = 0;
        obj = new Object[0][0];
        return;
      }
      rsMeta = rs.getMetaData();
      //get column count
      columns = rsMeta.getColumnCount();
      //calculate number of rows
      rows = 0;
      rs.first();
      do {
        rows++;
      } while (rs.next());
      //set array dimension
      obj = new Object [rows][columns];
      //load data
      rs.first();
      rows = 0;
      do {
        for (int j = 0; j <= (columns-1); j++) {
          obj[rows][j] = rs.getString(j+1);
        }
        rows++;
      } while (rs.next());
    } catch (Exception e1) {
    System.out.println(e1.getMessage());
    }
  }

    public int getColumnCount() {
          return columns;
    }

      public int getRowCount() {
          return rows;
      }

      public String getColumnName(int col)  {
        String res = "";
        if (rsMeta == null) {
          return res;
        }
        try {
          res = rsMeta.getColumnName(col+1);
        }
        catch (Exception e1) {
          System.out.println(e1.getMessage());
        }
        return res;
      }

      public Object getValueAt(int row, int col) {
          return obj[row][col];
      }
} //ResultTableModel class


class MainFrame_getAddressBtn_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_getAddressBtn_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.getAddressBtn_actionPerformed(e);
  }
}

class MainFrame_setAddressBtn_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_setAddressBtn_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.setAddressBtn_actionPerformed(e);
  }
}

/*class MainFrame_jButton1_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_jButton1_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}*/

class MainFrame_createTableBtn_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_createTableBtn_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.createTableBtn_actionPerformed(e);
  }
}

class MainFrame_changePasswordBtn_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_changePasswordBtn_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.changePasswordBtn_actionPerformed(e);
  }
}

class MainFrame_executeSelect_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_executeSelect_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.executeSelect_actionPerformed(e);
  }
}

class MainFrame_showInvoiceBtn_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_showInvoiceBtn_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.showInvoiceBtn_actionPerformed(e);
  }
}

class MainFrame_callStoredProcBtn_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_callStoredProcBtn_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.callStoredProcBtn_actionPerformed(e);
  }
}

class MainFrame_listProductsBtn_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_listProductsBtn_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.listProductsBtn_actionPerformed(e);
  }
}

class MainFrame_clearListBtn_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_clearListBtn_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.clearListBtn_actionPerformed(e);
  }
}
