﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Collections;
using Advantage.Data.Provider;

namespace CSharpNotifications
{
  public partial class MainForm : Form
  {

    static public MainForm me;
    private EmployeeNotification cn;
    private Thread workerThread;
    private String connName;

    public MainForm()
    {
      InitializeComponent();
      me = this;
    }

    private void MainForm_Load(object sender, EventArgs e)
    {
      // TODO: This line of code loads data into the 'dataSet1.EMPLOYEE' table. You can move, or remove it, as needed.
      this.eMPLOYEETableAdapter.Fill(this.dataSet1.EMPLOYEE);
      AdsConnection connection = new AdsConnection(eMPLOYEETableAdapter.Connection.ConnectionString);
      AdsCommand command = connection.CreateCommand();
      command.CommandText = "SELECT ::conn.Name FROM system.iota";
      connName = command.ExecuteScalar().ToString();
      cn = new EmployeeNotification(Properties.Settings.Default.ConnectionString, connName);
      workerThread = new Thread(cn.DoWork);
      workerThread.Start();
    }

    public void UpdateListbox(ArrayList aList)
    {
      listBox1.Items.Clear();
      for (int i = 0; i < aList.Count; i++)
      {
        listBox1.Items.Add(aList[i]);
      }
    }

    private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
    {
      cn.Terminate();
      workerThread.Join();
    }

  }
}
